;##################################################################
; Litho test
;##################################################################

#include "\RadASM\GoAsm\inc\debug.a"
DBGWIN_DEBUG_ON = 1 ; use this to enable Spy/StopSpy/DbgDump and TrapException
DBGWIN_SHOWONLYERRORS = 1 ; setting this to 1 will suppress PrintError if no error exists 

; Raster op codes for BitBlt
#include ROP.inc

#Define TRUE 1
#Define FALSE 0
#Define NULL 0

#Define WM_USER 0400h
#Define TBM_SETRANGE WM_USER+6
#Define TBM_SETBUDDY WM_USER + 32
#Define WM_INITDIALOG 110h
#Define WM_COMMAND 111h
#Define WM_HSCROLL 114h
#Define STM_SETIMAGE 172h
#Define IMAGE_BITMAP 0
#Define TB_ENDTRACK 8
#Define TBM_GETPOS WM_USER
#Define WM_CLOSE 10h
#Define LR_CREATEDIBSECTION 2000h
#Define LR_LOADFROMFILE 10h
#Define OFN_FILEMUSTEXIST 00001000h
#Define OFN_NONETWORKBUTTON 00020000h
#Define OFN_EXPLORER 00080000h
#Define OFN_HIDEREADONLY 00000004h
#Define MAX_PATH 260
#Define DIB_RGB_COLORS 0
#Define BI_RGB 0
#Define BI_BITFIELDS 3

#Define BM_GETCHECK 0F0h
#Define BST_CHECKED 1
#Define DST_BITMAP 4
#Define DSS_DISABLED 20h


#Define OPEN_EXISTING 3
#Define GENERIC_READ 80000000h
#Define GMEM_ZEROINIT 40h
#Define GMEM_FIXED 0
#Define FILE_BEGIN 0

POINT STRUCT
	x	DD
	y	DD
ENDS

BITMAP STRUCT
  bmType        DD
  bmWidth       DD
  bmHeight      DD
  bmWidthBytes  DD
  bmPlanes      DW
  bmBitsPixel   DW
  bmBits        DD
ENDS

RGBQUAD STRUCT
  rgbBlue       DB
  rgbGreen      DB
  rgbRed        DB
  rgbReserved   DB
ENDS

BITMAPFILEHEADER STRUCT
  bfType        DW
  bfSize        DD
  bfReserved1   DW
  bfReserved2   DW
  bfOffBits     DD
ENDS

BITMAPINFOHEADER STRUCT
  biSize            DD
  biWidth           DD
  biHeight          DD
  biPlanes          DW
  biBitCount        DW
  biCompression     DD
  biSizeImage       DD
  biXPelsPerMeter   DD
  biYPelsPerMeter   DD
  biClrUsed         DD
  biClrImportant    DD
ENDS

BITMAPINFO STRUCT
  bmiHeader  BITMAPINFOHEADER <?>
  bmiColors  RGBQUAD <?>
ENDS

DIBSECTION STRUCT
  dsBm            BITMAP <?>
  dsBmih          BITMAPINFOHEADER <?>
  dsBitfields     DD 3 DUP ?
  dshSection      DD
  dsOffset        DD
ENDS

OPENFILENAME STRUCT
  lStructSize        DD
  hwndOwner          DD
  hInstance          DD
  lpstrFilter        DD
  lpstrCustomFilter  DD
  nMaxCustFilter     DD
  nFilterIndex       DD
  lpstrFile          DD
  nMaxFile           DD
  lpstrFileTitle     DD
  nMaxFileTitle      DD
  lpstrInitialDir    DD
  lpstrTitle         DD
  Flags              DD
  nFileOffset        DW
  nFileExtension     DW
  lpstrDefExt        DD
  lCustData          DD
  lpfnHook           DD
  lpTemplateName     DD
ENDS

COLORCOUNT STRUCT
	dwColor		DD	?
	dwCount		DD	?
	pNext		DD	?
	padding		DD	? ; padd to 16 bits for easy addressing
ENDS

UNIQUECOLORS STRUCT
	dwColor		DD
	Next		DD
	RefCount	DD
	padding		DD
ENDS

.DATA
	szFilterStr		DB	"Bitmap files (*.bmp)",0,"*.bmp",0,0
	ALIGN 4
	szDefExt		DB	"bmp",0
	ALIGN 4
	szOpenCaption	DB	"Open file",0

	ofrFilePath		DB	MAX_PATH DUP (?)
	hBmp			DD	?
	hSkin			DD	?
	hPattern		DD	?
	hFixedBmp		DD	?
	hWatermark		DD	?

.CODE

;invoke CreateIndependantBitmap,0,0,0

Start:
	invoke InitCommonControls
	invoke GetModuleHandleA, 0
	invoke DialogBoxParamA,eax,1000,0,ADDR DlgProc,0
	invoke ExitProcess,259

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses edi,ebx,esi
	LOCAL hStatic	:D
	LOCAL bm		:BITMAP

	mov eax,[uMsg]
	cmp eax,WM_INITDIALOG
	jne >.WMCOMMAND
		invoke SendDlgItemMessageA,[hwnd],1002,TBM_SETRANGE,TRUE,0ff0000h
		invoke GetDlgItem,[hwnd],1003
		invoke SendDlgItemMessageA,[hwnd],1002,TBM_SETBUDDY,FALSE,eax
		invoke SetDlgItemInt,[hwnd],1003,0,FALSE
		jmp >>.EXIT

	.WMCOMMAND
	cmp eax,WM_COMMAND
	jne >>.WMHSCROLL
		cmp W[wParam],1004
		jne >C1
			invoke OpenBmp,[hwnd]
			or eax,eax
			jz >>.EXIT
			cmp D[hFixedBmp],0
			je >
				push eax
				invoke DeleteObject,[hFixedBmp]
				pop eax
			:
			mov [hFixedBmp],eax
			invoke CopyDIBImage,[hFixedBmp]
			mov [hBmp],eax
			invoke SendDlgItemMessageA,[hwnd],1001,STM_SETIMAGE,IMAGE_BITMAP,[hBmp]
			invoke DeleteObject,eax
			jmp >>.EXIT
		C1:
		cmp W[wParam],1006
		jne >C2
			invoke CopyDIBImage,[hFixedBmp]
			mov [hBmp],eax
			or eax,eax
			jz >>.EXIT
			invoke GrayScale,[hBmp]
			invoke SendDlgItemMessageA,[hwnd],1001,STM_SETIMAGE,IMAGE_BITMAP,[hBmp]
			invoke DeleteObject,eax
			jmp >>.EXIT
		C2:
		cmp W[wParam],1007
		jne >C3
			invoke CopyDIBImage,[hFixedBmp]
			mov [hBmp],eax
			or eax,eax
			jz >>.EXIT
			invoke EmbossImage,[hBmp],-128
			or eax,eax
			jz >
			mov [hBmp],eax
			:
			invoke SendDlgItemMessageA,[hwnd],1001,STM_SETIMAGE,IMAGE_BITMAP,[hBmp]
			invoke DeleteObject,eax
			jmp >>.EXIT
		C3:
		cmp W[wParam],1008
		jne >C4
			invoke CopyDIBImage,[hFixedBmp]
			mov [hBmp],eax
			or eax,eax
			jz >>.EXIT
			invoke InvertImage,[hBmp]
			invoke SendDlgItemMessageA,[hwnd],1001,STM_SETIMAGE,IMAGE_BITMAP,[hBmp]
			invoke DeleteObject,eax
			jmp >>.EXIT
		C4:
		cmp W[wParam],1009
		jne >>C5
			invoke CopyDIBImage,[hFixedBmp]
			mov [hBmp],eax
			or eax,eax
			jz >>.EXIT
			push eax
			invoke OpenBmp,[hwnd]
			or eax,eax
			jnz >
				pop eax
				invoke DeleteObject,[hBmp]
				jmp >>.EXIT
			:
			mov [hWatermark],eax
			invoke Watermark,[hWatermark],[hBmp],1,0,0,00FF8080h,00A00000h
			mov [hBmp],eax
			pop eax
			invoke DeleteObject,eax
			invoke SendDlgItemMessageA,[hwnd],1001,STM_SETIMAGE,IMAGE_BITMAP,[hBmp]
			invoke DeleteObject,eax
			invoke DeleteObject,[hWatermark]
			jmp >>.EXIT
		C5:
		cmp W[wParam],1010
		jne >>C6
			invoke CopyDIBImage,[hFixedBmp]
			mov [hPattern],eax
			or eax,eax
			jz >>.EXIT
			invoke OpenBmp,[hwnd]
			or eax,eax
			jnz >
				invoke DeleteObject,[hPattern]
				jmp >>.EXIT
			:
			mov [hSkin],eax
			invoke ApplySkin,[hPattern],[hSkin],0,0,0,00FF8080h,00A00000h
			mov [hBmp],eax
			invoke DeleteObject,[hSkin]
			invoke SendDlgItemMessageA,[hwnd],1001,STM_SETIMAGE,IMAGE_BITMAP,[hBmp]
			invoke DeleteObject,eax
			invoke DeleteObject,[hPattern]
			jmp >>.EXIT
		C6:
		cmp W[wParam],1011
		jne >C7
			invoke CopyDIBImage,[hFixedBmp]
			mov [hBmp],eax
			or eax,eax
			jz >>.EXIT
			invoke TraceEdges,[hBmp],127 ; 96 seems pretty good for photos
			invoke SendDlgItemMessageA,[hwnd],1001,STM_SETIMAGE,IMAGE_BITMAP,[hBmp]
			invoke DeleteObject,eax
			jmp >>.EXIT
		C7:
		cmp W[wParam],1012
		jne >>.EXIT
			invoke CopyDIBImage,[hFixedBmp]
			mov [hBmp],eax
			or eax,eax
			jz >>.EXIT
			push eax
			invoke Deg2Rad,45.0
			invoke GetRotatedBitmap,[hBmp],eax,00C0C0C0h
			mov [hBmp],eax
			pop eax
			invoke DeleteObject,eax
			invoke SendDlgItemMessageA,[hwnd],1001,STM_SETIMAGE,IMAGE_BITMAP,[hBmp]
			invoke DeleteObject,eax
			jmp >>.EXIT

	.WMHSCROLL
	cmp eax,WM_HSCROLL
	jne >>.WMCLOSE
		cmp D[hBmp],0
		je >>.EXIT
		cmp W[wParam],TB_ENDTRACK
		je >O1
			invoke SendDlgItemMessageA,[hwnd],1005,BM_GETCHECK,0,0
			test eax,BST_CHECKED
			jz >>O2
		O1:
			invoke CopyDIBImage,[hFixedBmp]
			mov [hBmp],eax
			or eax,eax
			jz >>.EXIT
			invoke SendDlgItemMessageA,[hwnd],1002,TBM_GETPOS,0,0
			push eax
			invoke LithoImage,[hBmp],eax
			invoke GetDlgItem,[hwnd],1001
			mov [hStatic],eax
			invoke SendMessageA,[hStatic],STM_SETIMAGE,IMAGE_BITMAP,[hBmp]
			invoke DeleteObject,eax
			pop eax
			invoke SetDlgItemInt,[hwnd],1003,eax,FALSE
			jmp >.EXIT
		O2:
			invoke SendDlgItemMessageA,[hwnd],1002,TBM_GETPOS,0,0
			invoke SetDlgItemInt,[hwnd],1003,eax,FALSE
			jmp >.EXIT

	.WMCLOSE
	cmp eax,WM_CLOSE
	jne >.DEFPROC
		invoke DeleteObject,[hBmp]
		invoke EndDialog,[hwnd],0

	.DEFPROC
		xor eax,eax
		ret

	.EXIT

	xor eax,eax
	inc eax
	ret
ENDF

GrayScale FRAME hBitmap
	uses edi,esi,ebx
	LOCAL dibs		:DIBSECTION

	invoke GetObjectA,[hBitmap],SIZEOF DIBSECTION,offset dibs
	or eax,eax
	jnz >
		ret
	:


	mov esi,[dibs.dsBm.bmBits]
	mov eax,[dibs.dsBm.bmWidthBytes]
	mul D[dibs.dsBm.bmHeight]
	mov ebx,eax
	shr ebx,2
	sub ebx,1

	.SCAN
		mov eax,[esi+ebx*4]
		bswap eax
		shr eax,8

		movzx ecx,al		; red
		imul ecx,ecx,66
		movzx edx,ah		; green
		imul edx,edx,129
		add edx,ecx
		shr eax,16			; blue
		imul eax,eax,25
		add eax,edx
		add eax,128
		shr eax,8
		add eax,16

		imul eax, eax,010101h
		mov [esi+ebx*4],eax
		dec ebx
	jns <.SCAN
	
	mov eax,[hBitmap]
	
	RET
ENDF

LithoImage FRAME hBitmap,Threshhold
	uses edi,esi,ebx
	LOCAL hdc		:D
	LOCAL memdc		:D
	LOCAL oldObj	:D
	LOCAL dibs		:DIBSECTION
	LOCAL White		:D
	LOCAL Black		:D

	; Negative Threshold inverts white and black
	mov D[Black],0
	mov D[White],0FFFFFFh

	mov eax,[Threshhold]
	or eax,eax
	jns >
	mov D[Black],0FFFFFFh
	mov D[White],0
	neg eax
	mov [Threshhold],eax
	:

	invoke GetObjectA,[hBitmap],SIZEOF DIBSECTION,offset dibs
	or eax,eax
	jnz >
		ret
	:

	mov esi,[dibs.dsBm.bmBits]
	mov eax,[dibs.dsBm.bmWidthBytes]
	mul D[dibs.dsBm.bmHeight]
	mov ebx,eax
	shr ebx,2
	sub ebx,1

	.SCAN
		mov eax,[esi+ebx*4]
		bswap eax
		shr eax,8

		movzx ecx,al		; red
		imul ecx,ecx,66
		movzx edx,ah		; green
		imul edx,edx,129
		add edx,ecx
		shr eax,16			; blue
		imul eax,eax,25
		add eax,edx
		add eax,128
		shr eax,8
		add eax,16

		cmp eax,[Threshhold]
		jg >
			mov eax,[Black]
			mov D[esi],eax
			jmp >.NXTPIXEL
		:
			mov eax,[White]
			mov D[esi],eax
		.NXTPIXEL
		mov [esi+ebx*4],eax
		dec ebx
	jns <.SCAN

	mov eax,[hBitmap]
	ret
ENDF

InvertImage FRAME hBitmap
		uses edi,esi,ebx
	LOCAL hdc		:D
	LOCAL memdc		:D
	LOCAL oldObj	:D
	LOCAL dibs		:DIBSECTION

	invoke GetObjectA,[hBitmap],SIZEOF DIBSECTION,offset dibs
	or eax,eax
	jnz >
		ret
	:

	mov esi,[dibs.dsBm.bmBits]
	mov eax,[dibs.dsBm.bmWidthBytes]
	mul D[dibs.dsBm.bmHeight]
	mov ebx,eax
	shr ebx,2
	sub ebx,1

	.SCAN
		mov eax,[esi+ebx*4]
		bswap eax
		shr eax,8

		mov ecx,0FFFFFFh
		sub ecx,eax
		mov [esi+ebx*4],ecx
		dec ebx
	jns <.SCAN
	
	mov eax,[hBitmap]
	ret
ENDF

CopyDIBImage FRAME hBitmap
		uses edi,esi,ebx
	LOCAL hDest		:D
	LOCAL dibs		:DIBSECTION
	LOCAL dibs2		:DIBSECTION

	invoke GetObjectA,[hBitmap],SIZEOF DIBSECTION,offset dibs
	or eax,eax
	jnz >
		ret
	:

	invoke GetDC,0
	push eax
	invoke CreateIndependantBitmap,eax,[dibs.dsBm.bmWidth],[dibs.dsBm.bmHeight]
	mov [hDest],eax
	pop eax
	invoke ReleaseDC,0,eax

	invoke GetObjectA,[hDest],SIZEOF DIBSECTION,offset dibs2
	or eax,eax
	jnz >
		ret
	:

	mov esi,[dibs.dsBm.bmBits]
	mov edi,[dibs2.dsBm.bmBits]
	mov eax,[dibs.dsBm.bmWidthBytes]
	mul D[dibs.dsBm.bmHeight]
	mov ebx,eax
	shr ebx,2
	sub ebx,1

	.SCAN
		mov eax,[esi+ebx*4]
		mov [edi+ebx*4],eax
		dec ebx
	jns <.SCAN

	mov eax,[hDest]
	ret

ENDF

EmbossImage FRAME hBitmap, Threshhold
	LOCAL hTmpBmp		:D
	LOCAL hdc			:D
	LOCAL memdc			:D
	LOCAL dibs			:DIBSECTION

	invoke GetObjectA,[hBitmap],SIZEOF DIBSECTION,offset dibs
	or eax,eax
	jnz >
		ret
	:

	invoke LithoImage,[hBitmap],[Threshhold]

	invoke GetDC,NULL
	mov [hdc],eax
	invoke CreateCompatibleDC,[hdc]
	mov [memdc],eax
	invoke ReleaseDC,NULL,[hdc]

	invoke CreateIndependantBitmap,[memdc],[dibs.dsBm.bmWidth],[dibs.dsBm.bmHeight]
	mov [hTmpBmp],eax

	invoke SelectObject,[memdc],[hTmpBmp]
	push eax

	invoke DrawStateA,[memdc],0,0,[hBitmap],0,0,0, \
		[dibs.dsBm.bmWidth],[dibs.dsBm.bmHeight],DST_BITMAP+DSS_DISABLED

	pop eax
	invoke SelectObject,[memdc],eax

	invoke DeleteDC,[memdc]
	invoke DeleteObject,[hBitmap]
	mov eax,[hTmpBmp]
	RET
ENDF

Watermark FRAME hBitmap,hbmBackGnd,bRaised,xDest,yDest,clrHighlight,clrShadow
	; From a C routine by Zafir Anjum
	; http://www.codeguru.com/Cpp/G-M/bitmap/specialeffects/article.php/c1685/
	; Palette code was removed, comments kept intact

	///////////////////////////////////////////////////////////////////////////////////
	// Watermark		- Creates a 3D embossed effect (Originally called Emboss)
	// Returns			- A new bitmap containing the resulting effect
	// hBitmap			- Bitmap that contains the basic text & shapes
	// hbmBackGnd		- Contains the color image 
	// bRaised			- True if raised effect is desired. False for sunken effect
	// xDest			- x coordinate - used to offset hBitmap
	// yDest			- y coordinate - used to offset hBitmap
	// clrHightlight	- Color used for the highlight edge
	// clrShadow		- Color used for the shadow
	//
	// Note				- 1. Neither of the bitmap handles passed in should be selected 
	//			  		in a device context.
	//			  		- 2. The pixel at 0,0 in hBitmap is considered the background color
	//
	///////////////////////////////////////////////////////////////////////////////////

	LOCAL bmInfo	:BITMAP
	LOCAL bm		:BITMAP
	LOCAL hbmOld, hbmShadow, hbmHighlight, hbmResult, hbmOldMem,hbrPat	:D
	LOCAL hDC, hColorDC, hMonoDC, hMemDC	:D

	cmp D[bRaised],0
	jne >
		// Swap the highlight and shadow color
		mov eax,[clrShadow]
		mov ecx,[clrHighlight]
		mov [clrShadow],ecx
		mov [clrHighlight],eax
	:
	
	// We create two monochrome bitmaps. One of them will contain the
	// highlighted edge and the other will contain the shadow. These
	// bitmaps are then used to paint the highlight and shadow on the
	// background image.
	
	mov D[hbmResult],0
	invoke GetDC,0
	mov [hDC],eax

	// Create a compatible DCs
	invoke CreateCompatibleDC,[hDC]
	mov [hMemDC],eax
	invoke CreateCompatibleDC,[hDC]
	mov [hMonoDC],eax
	invoke CreateCompatibleDC,[hDC]
	mov [hColorDC],eax

	// Select the background image into memory DC so that we can draw it
	invoke SelectObject,[hMemDC],[hbmBackGnd]
	mov [hbmOldMem],eax

	// Get dimensions of the background image
	invoke GetObjectA,[hbmBackGnd],SIZEOF BITMAP,offset bm

	// Create the monochrome and compatible color bitmaps
	invoke GetObjectA,[hBitmap],SIZEOF BITMAP,offset bmInfo
	invoke CreateBitmap,[bmInfo.bmWidth], [bmInfo.bmHeight], 1, 1, NULL
	mov [hbmShadow],eax
	invoke CreateBitmap,[bmInfo.bmWidth], [bmInfo.bmHeight], 1, 1, NULL
	mov [hbmHighlight],eax
	invoke CreateIndependantBitmap, [hDC], [bm.bmWidth], [bm.bmHeight]
	mov [hbmResult],eax
	
	invoke SelectObject,[hColorDC], [hBitmap]
	mov [hbmOld],eax

	// Set background color of bitmap for mono conversion
	// We assume that the pixel in the top left corner has the background color
	invoke GetPixel,[hColorDC],0,0
	invoke SetBkColor,[hColorDC],eax

	// Create the highlight bitmap.
	invoke SelectObject,[hMonoDC],[hbmHighlight]
	mov [hbmHighlight],eax
	invoke PatBlt,[hMonoDC], 0, 0, [bmInfo.bmWidth], [bmInfo.bmHeight], WHITENESS
	mov eax,[bmInfo.bmWidth]
	dec eax
	mov ecx,[bmInfo.bmHeight]
	dec ecx
	invoke BitBlt,[hMonoDC], 0, 0, eax, ecx, [hColorDC], 1, 1, SRCCOPY
	invoke BitBlt, [hMonoDC], 0, 0, [bmInfo.bmWidth], [bmInfo.bmHeight], \
		[hColorDC], 0, 0, MERGEPAINT
	invoke SelectObject,[hMonoDC],[hbmHighlight]
	mov [hbmHighlight],eax

	// create the shadow bitmap
	invoke SelectObject,[hMonoDC],[hbmShadow]
	mov [hbmShadow],eax
	invoke PatBlt,[hMonoDC], 0, 0, [bmInfo.bmWidth], [bmInfo.bmHeight], WHITENESS

	mov eax,[bmInfo.bmWidth]
	dec eax
	mov ecx,[bmInfo.bmHeight]
	dec ecx
	invoke BitBlt,[hMonoDC], 1, 1, eax, ecx, [hColorDC], 0, 0, SRCCOPY
	invoke BitBlt, [hMonoDC], 0, 0, [bmInfo.bmWidth], [bmInfo.bmHeight], \
		[hColorDC], 0, 0, MERGEPAINT
	invoke SelectObject,[hMonoDC],[hbmShadow]
	mov [hbmShadow],eax

	// Now let's start working on the final image
	invoke SelectObject,[hColorDC], [hbmResult]

	// Draw the background image
	invoke BitBlt,[hColorDC], 0, 0, [bm.bmWidth], [bm.bmHeight], [hMemDC], 0, 0,SRCCOPY
	// Restore the old bitmap in the hMemDC
	invoke SelectObject, [hMemDC], [hbmOldMem]

	// Set the background and foreground color for the raster operations
	invoke SetBkColor, [hColorDC], 0FFFFFFh
	invoke SetTextColor, [hColorDC], 0

	// blt the highlight edge
	invoke CreateSolidBrush, [clrHighlight]
	mov [hbrPat],eax
	invoke SelectObject, [hColorDC], [hbrPat]
	mov [hbrPat],eax
	invoke SelectObject, [hMonoDC], [hbmHighlight]
	mov [hbmHighlight],eax
	invoke BitBlt, [hColorDC], [xDest], [yDest], [bmInfo.bmWidth], [bmInfo.bmHeight], \
		[hMonoDC], 0, 0, ROP_PSDPxax
	invoke SelectObject, [hColorDC], [hbrPat]
	invoke DeleteObject, eax
	invoke SelectObject, [hMonoDC], [hbmHighlight]
	mov [hbmHighlight],eax
	
	// blt the shadow edge
	invoke CreateSolidBrush, [clrShadow]
	mov [hbrPat],eax
	invoke SelectObject, [hColorDC], [hbrPat]
	mov [hbrPat],eax
	invoke SelectObject, [hMonoDC], [hbmShadow]
	mov [hbmShadow],eax
	invoke BitBlt, [hColorDC], [xDest], [yDest], [bmInfo.bmWidth], [bmInfo.bmHeight], \
		[hMonoDC], 0, 0, ROP_PSDPxax
	invoke SelectObject, [hColorDC], [hbrPat]
	invoke DeleteObject, eax
	invoke SelectObject, [hMonoDC], [hbmShadow]
	mov [hbmShadow],eax

	// select old bitmap into color DC 
	invoke SelectObject, [hColorDC], [hbmOld]
	
	invoke DeleteObject, [hbmShadow]
	invoke DeleteObject, [hbmHighlight]
	
	invoke ReleaseDC, NULL, [hDC]

	mov eax, [hbmResult] 

	RET
ENDF

TraceEdges FRAME hBitmap, Threshold
	LOCAL hTLdc			:D
	LOCAL hBRdc			:D
	LOCAL hMasterDC		:D
	LOCAL memdc			:D
	LOCAL hdc			:D
	LOCAL hTLBmp		:D
	LOCAL hBRBmp		:D
	LOCAL hmemBmp			:D
	LOCAL hOldBmp		:D
	LOCAL bm			:BITMAP
	
	invoke GetDC,NULL
	mov [hdc],eax
	invoke CreateCompatibleDC,[hdc]
	mov [memdc],eax
	invoke CreateCompatibleDC,[hdc]
	mov [hTLdc],eax
	invoke CreateCompatibleDC,[hdc]
	mov [hBRdc],eax
	invoke CreateCompatibleDC,[hdc]
	mov [hMasterDC],eax

	; Get the dimensions of the bitmap
	invoke GetObjectA,[hBitmap],SIZEOF BITMAP,offset bm

	; Create 3 Monochrome bitmaps
	invoke CreateBitmap,[bm.bmWidth],[bm.bmHeight],1,1,0
	mov [hTLBmp],eax
	invoke CreateBitmap,[bm.bmWidth],[bm.bmHeight],1,1,0
	mov [hBRBmp],eax
	invoke CreateBitmap,[bm.bmWidth],[bm.bmHeight],1,1,0
	mov [hmemBmp],eax
	invoke ReleaseDC,NULL,[hdc]

	; Use LithoImage to convert to B&W
	invoke LithoImage,[hBitmap],[Threshold]

	; Select the master bitmap into the memdc
	invoke SelectObject,[hMasterDC],[hBitmap]
	mov [hOldBmp],eax

	; Select the main bitmap into the memdc
	invoke SelectObject,[memdc],[hmemBmp]
	mov [hmemBmp],eax

	; Blt the main bitmap to make it monochrome
	invoke BitBlt,[memdc],0,0,[bm.bmWidth],[bm.bmHeight],[hMasterDC],0,0,SRCCOPY

	invoke SetBkColor,[hTLdc],0FFFFFFh
	invoke SetBkColor,[hBRdc],0FFFFFFh
	invoke SetTextColor,[hTLdc],0h
	invoke SetTextColor,[hBRdc],0h

	; Select the 2 monochrome bitmaps into their DCs
	invoke SelectObject,[hTLdc],[hTLBmp]
	mov [hTLBmp],eax
	invoke SelectObject,[hBRdc],[hBRBmp]
	mov [hBRBmp],eax

	; Fill the two monochrome bitmaps with white
	invoke PatBlt,[hTLdc],0,0,[bm.bmWidth],[bm.bmHeight],WHITENESS
	invoke PatBlt,[hBRdc],0,0,[bm.bmWidth],[bm.bmHeight],WHITENESS
	
	; Blt the bitmaps in offset 1,1
	mov eax,[bm.bmWidth]
	dec eax
	mov ecx,[bm.bmHeight]
	dec ecx
	invoke BitBlt,[hTLdc],0,0,eax,ecx,[memdc],1,1,SRCCOPY
	invoke BitBlt, [hTLdc], 0, 0, [bm.bmWidth], [bm.bmHeight], \
		[memdc], 0, 0, MERGEPAINT

	mov eax,[bm.bmWidth]
	dec eax
	mov ecx,[bm.bmHeight]
	dec ecx
	invoke BitBlt,[hBRdc],1,1,eax,ecx,[memdc],0,0,SRCCOPY
	invoke BitBlt, [hBRdc], 0, 0, [bm.bmWidth], [bm.bmHeight], \
		[memdc], 0, 0, MERGEPAINT

	invoke SelectObject,[memdc],[hmemBmp]
	invoke DeleteObject,eax

	; Combine the 2 images
	invoke BitBlt,[hMasterDC],0,0,[bm.bmWidth], [bm.bmHeight],[hTLdc],0,0,SRCCOPY
	invoke BitBlt,[hMasterDC],0,0,[bm.bmWidth], [bm.bmHeight],[hBRdc],0,0,SRCAND

	invoke SelectObject,[hTLdc],[hTLBmp]
	invoke DeleteObject,eax
	invoke SelectObject,[hBRdc],[hBRBmp]
	invoke DeleteObject,eax

	invoke SelectObject,[hMasterDC],[hOldBmp]
	push eax
	invoke DeleteDC,[memdc]
	invoke DeleteDC,[hMasterDC]
	invoke DeleteDC,[hBRdc]
	invoke DeleteDC,[hTLdc]
	pop eax

	RET
ENDF

ApplySkin FRAME hBitmap,hbmPattern,bRaised,xDest,yDest,clrHighlight,clrShadow
	; From a C routine by Zafir Anjum
	; http://www.codeguru.com/Cpp/G-M/bitmap/specialeffects/article.php/c1745/
	; Palette code was removed, comments kept intact

	/////////////////////////////////////////////////////////////////////////////////////
	// ApplySkin		- Creates a 3D effect and draws the pattern on the foreground
	//			  		  but leaves the background alone (Originally called EmbossPattern)
	// Returns			- A new bitmap containing the resulting effect
	// hBitmap			- Bitmap that contains the basic text & shapes
	// hbmBackGnd		- Contains the color image 
	// bRaised			- True if raised effect is desired. False for sunken effect
	// xDest			- x coordinate - used to offset hBitmap
	// yDest			- y coordinate - used to offset hBitmap
	// clrHightlight	- Color used for the highlight edge
	// clrShadow		- Color used for the shadow
	//
	// Note				- 1. Neither of the bitmap handles passed in should be selected 
	//					  in a device context.
	//					- 2. The pixel at 0,0 in hBitmap is considered the background color
	//
	/////////////////////////////////////////////////////////////////////////////////////

	LOCAL bmInfo	:BITMAP
	LOCAL bm		:BITMAP
	LOCAL hbmOld, hbmShadow, hbmHighlight, hbmResult, hbmOldMem, hbmMono, hbrPat	:D
	LOCAL hDC, hColorDC, hMonoDC, hMemDC, clrBackGnd:D

	cmp D[bRaised],0
	jne >
		// Swap the highlight and shadow color
		mov eax,[clrShadow]
		mov ecx,[clrHighlight]
		mov [clrShadow],ecx
		mov [clrHighlight],eax
	:

	// We create two monochrome bitmaps. One of them will contain the
	// highlighted edge and the other will contain the shadow. These
	// bitmaps are then used to paint the highlight and shadow on the
	// background image.
	
	mov D[hbmResult],0
	invoke GetDC,0
	mov [hDC],eax

	// Create a compatible DCs
	invoke CreateCompatibleDC,[hDC]
	mov [hMemDC],eax
	invoke CreateCompatibleDC,[hDC]
	mov [hMonoDC],eax
	invoke CreateCompatibleDC,[hDC]
	mov [hColorDC],eax

	// Select the background image into memory DC so that we can draw it
	invoke SelectObject,[hMemDC],[hbmPattern]
	mov [hbmOldMem],eax

	// Get dimensions of the background image
	invoke GetObjectA,[hbmPattern],SIZEOF BITMAP,offset bm

	// Create the monochrome and compatible color bitmaps
	invoke GetObjectA,[hBitmap],SIZEOF BITMAP,offset bmInfo
	invoke CreateBitmap,[bmInfo.bmWidth], [bmInfo.bmHeight], 1, 1, NULL
	mov [hbmMono],eax
	invoke CreateBitmap,[bmInfo.bmWidth], [bmInfo.bmHeight], 1, 1, NULL
	mov [hbmShadow],eax
	invoke CreateBitmap,[bmInfo.bmWidth], [bmInfo.bmHeight], 1, 1, NULL
	mov [hbmHighlight],eax
	invoke CreateIndependantBitmap, [hDC], [bm.bmWidth], [bm.bmHeight]
	mov [hbmResult],eax

	invoke SelectObject,[hColorDC], [hBitmap]
	mov [hbmOld],eax

	// Set background color of bitmap for mono conversion
	// We assume that the pixel in the top left corner has the background color
	invoke GetPixel, [hColorDC], 10, 10
	mov [clrBackGnd],eax
	invoke SetBkColor, [hColorDC], eax

	// Create the monochrome version of the bitmap.
	invoke SelectObject, [hMonoDC], [hbmMono]
	mov [hbmMono], eax
	invoke BitBlt, [hMonoDC], 0, 0, [bmInfo.bmWidth], [bmInfo.bmHeight], \
		[hColorDC], 0, 0, SRCCOPY
	invoke SelectObject, [hMonoDC], [hbmMono]
	mov [hbmMono], eax

	// Create the highlight bitmap.
	invoke SelectObject, [hMonoDC], [hbmHighlight]
	mov [hbmHighlight], eax
	invoke PatBlt, [hMonoDC], 0, 0, [bmInfo.bmWidth], [bmInfo.bmHeight], WHITENESS
	mov eax,[bmInfo.bmHeight]
	dec eax
	mov ecx,[bmInfo.bmWidth]
	dec ecx
	invoke BitBlt, [hMonoDC], 0, 0, ecx,  eax, [hColorDC], 1, 1, SRCCOPY
	invoke BitBlt, [hMonoDC], 0, 0, [bmInfo.bmWidth], [bmInfo.bmHeight], \
		[hColorDC], 0, 0, MERGEPAINT
	invoke SelectObject, [hMonoDC], [hbmHighlight]
	mov [hbmHighlight] ,eax

	// create the shadow bitmap
	invoke SelectObject, [hMonoDC], [hbmShadow]
	mov [hbmShadow], eax
	invoke PatBlt, [hMonoDC], 0, 0, [bmInfo.bmWidth], [bmInfo.bmHeight], WHITENESS
	mov eax,[bmInfo.bmHeight]
	dec eax
	mov ecx,[bmInfo.bmWidth]
	dec ecx
	invoke BitBlt, [hMonoDC], 1, 1, ecx, eax, [hColorDC], 0, 0, SRCCOPY
	invoke BitBlt, [hMonoDC], 0, 0, [bmInfo.bmWidth], [bmInfo.bmHeight], \
		[hColorDC], 0, 0, MERGEPAINT
	invoke SelectObject, [hMonoDC], [hbmShadow]
	mov [hbmShadow], eax

	// Now let's start working on the final image
	invoke SelectObject, [hColorDC], [hbmResult]

	// Draw the pattern image - tile it if needed
	xor ebx,ebx
	L1:
		xor edi,edi
		L2:
			invoke BitBlt, [hColorDC], ebx, edi, [bm.bmWidth], [bm.bmWidth], [hMemDC], \ 
					0, 0,SRCCOPY
			add edi,[bm.bmHeight]
			cmp edi,[bmInfo.bmHeight]
		jl <L2
	add ebx,[bm.bmWidth]
	cmp ebx,[bmInfo.bmWidth]
	jl <L1

	// Restore the old bitmap in the hMemDC
	invoke SelectObject, [hMemDC], [hbmOldMem]
	
	// Set the background and foreground color for the raster operations
	invoke SetBkColor, [hColorDC], 0
	invoke SetTextColor, [hColorDC], 0FFFFFFh

	invoke CreateSolidBrush, [clrBackGnd]
	mov [hbrPat],eax
	invoke SelectObject, [hColorDC], [hbrPat]
	mov [hbrPat],eax
	invoke SelectObject, [hMonoDC], [hbmMono]
	mov [hbmMono], eax
	invoke BitBlt, [hColorDC], 0, 0, [bmInfo.bmWidth], [bmInfo.bmHeight], \
		[hMonoDC], 0, 0, ROP_PSDPxax
	invoke SelectObject, [hColorDC], [hbrPat]
	invoke DeleteObject, eax
	invoke SelectObject, [hMonoDC], [hbmMono]
	mov [hbmMono], eax

	// Set the background and foreground color for the raster operations
	invoke SetBkColor, [hColorDC], 0FFFFFFh
	invoke SetTextColor, [hColorDC], 0

	// blt the highlight edge
	invoke CreateSolidBrush, [clrHighlight]
	mov [hbrPat],eax
	invoke SelectObject, [hColorDC], [hbrPat]
	mov [hbrPat], eax
	invoke SelectObject, [hMonoDC], [hbmHighlight]
	mov [hbmHighlight], eax
	invoke BitBlt, [hColorDC], 0, 0, [bmInfo.bmWidth], [bmInfo.bmHeight], \
		[hMonoDC], 0, 0, ROP_PSDPxax
	invoke SelectObject, [hColorDC], [hbrPat]
	invoke DeleteObject, eax
	invoke SelectObject, [hMonoDC], [hbmHighlight]
	mov [hbmHighlight], eax

	// blt the shadow edge
	invoke CreateSolidBrush, [clrShadow]
	mov [hbrPat], eax
	invoke SelectObject, [hColorDC], [hbrPat]
	mov [hbrPat], eax 
	invoke SelectObject, [hMonoDC], [hbmShadow]
	mov [hbmShadow],eax
	invoke BitBlt, [hColorDC], 0, 0, [bmInfo.bmWidth], [bmInfo.bmHeight], \
		[hMonoDC], 0, 0, ROP_PSDPxax
	invoke SelectObject, [hColorDC], [hbrPat]
	invoke DeleteObject, eax
	invoke SelectObject, [hMonoDC], [hbmShadow]
	mov [hbmShadow], eax

	// select old bitmap into color DC 
	invoke SelectObject, [hColorDC], [hbmOld]
	
	invoke DeleteObject, [hbmMono]
	invoke DeleteObject, [hbmShadow]
	invoke DeleteObject, [hbmHighlight]
	
	invoke ReleaseDC, NULL, [hDC]

	mov eax,[hbmResult]

	RET
ENDF

OpenBmp FRAME hDlg
	LOCAL ofn				:OPENFILENAME
	LOCAL ofrFileTitle[64]	:B
	LOCAL hBmpLoaded		:D
	LOCAL hDIBBmp			:D
	LOCAL hdc				:D
	LOCAL memdc1			:D
	LOCAL memdc2			:D
	LOCAL Oldobj1			:D
	LOCAL Oldobj2			:D
	LOCAL dibs				:DIBSECTION

	mov D[ofn.lStructSize],SIZEOF OPENFILENAME
	mov eax,[hDlg]
	mov [ofn.hwndOwner],eax
	invoke GetModuleHandleA,0
	mov D[ofn.hInstance],NULL
	mov [ofn.lpstrFilter],OFFSET szFilterStr
	mov D[ofn.lpstrCustomFilter],NULL
	mov D[ofn.nMaxCustFilter],NULL
	mov D[ofn.nFilterIndex],1
	mov eax,OFFSET ofrFilePath
	mov D[eax],0
	mov [ofn.lpstrFile],eax
	mov D[ofn.nMaxFile],MAX_PATH
	mov D[ofn.lpstrFileTitle],NULL
	mov D[ofn.nMaxFileTitle],NULL
	mov D[ofn.lpstrInitialDir],NULL
	mov [ofn.lpstrTitle],OFFSET szOpenCaption
	mov D[ofn.Flags],OFN_FILEMUSTEXIST + OFN_NONETWORKBUTTON + OFN_EXPLORER + OFN_HIDEREADONLY
	mov D[ofn.lpfnHook],NULL
	mov D[ofn.lpTemplateName],NULL
	mov [ofn.lpstrDefExt],OFFSET szDefExt
	mov D[ofn.lCustData],NULL

	invoke GetOpenFileNameA,ADDR ofn
	or eax,eax
	jnz >
		ret
	:
	
	invoke LoadImageA,NULL,offset ofrFilePath,IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION + LR_LOADFROMFILE
	mov [hBmpLoaded],eax
	or eax,eax
	jnz >
		ret
	:

	invoke ConvertToDIB32,[hBmpLoaded]
	ret

ENDF

ConvertToDIB32 FRAME hBitmap
	LOCAL hdc		:D
	LOCAL memdc1	:D
	LOCAL memdc2	:D
	LOCAL hDIBBmp	:D
	LOCAL dibs		:BITMAP

	invoke GetObjectA,[hBitmap],SIZEOF BITMAP,offset dibs
	mov eax,[dibs.bmBitsPixel]
	cmp eax,32
	jne >
		mov eax,[hBitmap]
		ret
	:

	invoke GetDC,NULL
	mov [hdc],eax
	invoke CreateCompatibleDC,[hdc]
	mov [memdc1],eax
	invoke CreateCompatibleDC,[hdc]
	mov [memdc2],eax

	invoke CreateIndependantBitmap,[hdc],[dibs.bmWidth],[dibs.bmHeight]
	mov [hDIBBmp],eax
	invoke ReleaseDC,NULL,[hdc]

	invoke SelectObject,[memdc1],[hBitmap]
	mov [hBitmap],eax
	invoke SelectObject,[memdc2],[hDIBBmp]
	mov [hDIBBmp],eax
	invoke BitBlt,[memdc2],0,0,[dibs.bmWidth],[dibs.bmHeight],[memdc1],0,0,SRCCOPY

	invoke SelectObject,[memdc1],[hBitmap]
	invoke DeleteObject,eax
	invoke SelectObject,[memdc2],[hDIBBmp]
	mov [hDIBBmp],eax
	invoke DeleteDC,[memdc1]
	invoke DeleteDC,[memdc2]
	mov eax,[hDIBBmp]

	RET
ENDF

CreateIndependantBitmap FRAME hDC,SizeX,SizeY
	LOCAL bmi			:BITMAPINFO
	LOCAL ppvBits		:D

	mov D[bmi.bmiHeader.biSize],SIZEOF BITMAPINFOHEADER
	mov eax,[SizeX]
	mov [bmi.bmiHeader.biWidth],eax
	mov eax,[SizeY]
	mov D[bmi.bmiHeader.biHeight],eax
	mov W[bmi.bmiHeader.biPlanes],1
	mov W[bmi.bmiHeader.biBitCount],32
	mov D[bmi.bmiHeader.biCompression],BI_RGB
	invoke CreateDIBSection,[hDC],ADDR bmi,DIB_RGB_COLORS,ADDR ppvBits,NULL,NULL

	push eax
	invoke GdiFlush
	pop eax
	ret

ENDF

Deg2Rad FRAME Degrees
	LOCAL Val180	:D

	mov D[Val180],180.0
	fldpi
	fdiv D[Val180]
	fmul D[Degrees]
	fstp D[Val180]
	mov eax,[Val180]
	RET
ENDF

GetRotatedBitmap FRAME hDIB,radians,clrBack
	uses edi,esi,ebx
	; From a C routine by Zafir Anjum
	; This routine has been radically altered to support DIB sections
	; instead of straight DIBs, that way the results can be used immediately
	; and the pointers are easier to get.
	LOCAL bminfo				:DIBSECTION
	LOCAL bmInfoResult			:DIBSECTION
	LOCAL cosine,sine			:D ; REAL4
	LOCAL tfloat,tfloat1		:D ; REAL4
	LOCAL nHeight,nWidth		:D
	LOCAL negHeight				:D
	LOCAL nRowBytes				:D
	LOCAL lpDIBBits				:D
	LOCAL x1,x2,x3,maxx,minx,w	:D
	LOCAL y1,y2,y3,maxy,miny,h	:D
	LOCAL nResultRowBytes		:D
	LOCAL hDIBResult			:D
	LOCAL lpDIBBitsResult		:D
	LOCAL sourcex,sourcey		:D

	mov eax,[clrBack]
	bswap eax
	shr eax,8
	mov [clrBack],eax

	invoke GetObjectA,[hDIB],SIZEOF DIBSECTION,offset bminfo

	mov eax, [bminfo.dsBm.bmHeight]
	mov [nHeight],eax
	or eax,eax
	jns >
		; must be bottom up origin
		xor eax,eax
		ret
	:
	neg eax
	mov [negHeight],eax

	mov eax, [bminfo.dsBm.bmWidth]
	mov [nWidth],eax

	mov eax,[nWidth]
	shl eax,5 ; mul x 32 bpp
	add eax,31
	and eax,-31
	shr eax,3
	mov [nRowBytes],eax

	mov eax,[bminfo.dsBmih.biCompression]
	cmp eax,BI_RGB
	je >
		; must be uncompressed
		xor eax,eax
		ret
	:

	mov eax,[bminfo.dsBm.bmBits]
	mov [lpDIBBits],eax

	; I suck at FPU stuff

	fld D[radians]
	fcos
	fstp D[cosine]

	fld D[radians]
	fsin
	fstp D[sine]

	fild D[negHeight]
	fmul D[sine]
	fistp D[x1]

	fild D[nHeight]
	fmul D[cosine]
	fistp D[y1]

	fild D[nHeight]
	fmul D[sine]
	fstp D[tfloat]

	fild D[nWidth]
	fmul D[cosine]
	fsub D[tfloat]
	fistp D[x2]

	fild D[nWidth]
	fmul D[sine]
	fstp D[tfloat]

	fild D[nHeight]
	fmul D[cosine]
	fadd D[tfloat]
	fistp D[y2]


	fild D[nWidth]
	fmul D[cosine]
	fistp D[x3]

	fild D[nWidth]
	fmul D[sine]
	fistp D[y3]

	; Find the minimum x quantity
	mov eax,[x1]
	cmp eax,[x2]
	jl >
		mov eax,[x2]
		:
		cmp eax,[x3]
		jl >
		mov eax,[x3]
	:
	cmp eax,0
	jl >
	mov eax,0
	:
	mov [minx],eax

	; Find the minimum y quantity
	mov eax,[y1]
	cmp eax,[y2]
	jl >
		mov eax,[y2]
		:
		cmp eax,[y3]
		jl >
		mov eax,[y3]
	:
	cmp eax,0
	jl >
	mov eax,0
	:
	mov [miny],eax

	mov eax,[x1]
	cmp eax,[x2]
	jg >
		mov eax,[x2]
		:
		cmp eax,[x3]
		jg >
		mov eax,[x3]
	:
	cmp eax,0
	jge >
	xor eax,eax
	:
	mov [maxx],eax

	sub eax,[minx]
	mov [w],eax

	mov eax,[y1]
	cmp eax,[y2]
	jg >
		mov eax,[y2]
		:
		cmp eax,[y3]
		jg >
		mov eax,[y3]
	:
	cmp eax,0
	jge >
	xor eax,eax
	:
	mov [maxy],eax
	sub eax,[miny]
	mov [h],eax

	mov eax,[w]
	shl eax,5 ; mul x 32 bpp
	add eax,31
	and eax,-31
	shr eax,3
	mov [nResultRowBytes],eax

	invoke GetDC,0
	push eax
	invoke CreateIndependantBitmap,eax,[w],[h]
	mov [hDIBResult],eax
	pop eax
	invoke ReleaseDC,0,eax

	invoke GetObjectA,[hDIBResult],SIZEOF DIBSECTION,offset bmInfoResult
	mov eax,[bmInfoResult.dsBm.bmBits]
	mov [lpDIBBitsResult],eax

	xor edi,edi
	L1:
		xor esi,esi
		L2:	
			mov eax,esi
			add eax,[minx]
			mov [tfloat],eax
			fild D[tfloat]
			fmul D[cosine]
			fstp D[tfloat]

			mov eax,edi
			add eax,[miny]
			mov [tfloat1],eax
			fild D[tfloat1]
			fmul D[sine]
			fadd D[tfloat]
			fistp D[sourcex]

			mov eax,esi
			add eax,[minx]
			mov [tfloat],eax
			fild D[tfloat]
			fmul D[sine]
			fstp D[tfloat]

			mov eax,edi
			add eax,[miny]
			mov [tfloat1],eax
			fild D[tfloat1]
			fmul D[cosine]
			fsub D[tfloat]
			fistp D[sourcey]

			cmp D[sourcex],0
			jl >>L3
			mov eax,[nWidth]
			cmp D[sourcex],eax
			jge >>L3
			cmp D[sourcey],0
			jl >>L3
			mov eax,[nHeight]
			cmp D[sourcey],eax
			jge >>L3

				mov ecx,[lpDIBBits]
				mov eax,[nRowBytes]
				mul D[sourcey]
				add ecx,eax
				mov eax,[sourcex]
				shl eax,2
				add ecx,eax
				mov ebx,[ecx]

				mov ecx,[lpDIBBitsResult]
				mov eax,[nResultRowBytes]

				mul edi
				add ecx,eax
				mov eax, esi
				shl eax,2
				add ecx,eax
				mov [ecx],ebx
				jmp >>L4
			L3:
				mov ecx,[lpDIBBitsResult]
				mov eax,[nResultRowBytes]
				mul edi
				add ecx,eax
				mov eax,esi
				shl eax,2
				add ecx,eax
				mov eax,[clrBack]
				mov [ecx],eax
			L4:
		inc esi
		cmp esi,[w]
		jl <<L2

	inc edi
	cmp edi,[h]
	jl <<L1

	mov eax,[hDIBResult]

	RET
ENDF

